/* Full Motion Video PC-Engine demo
   WARNING - For HuC V1.2+ only !!!
   (c)   07/08/2000    Ishan/Utopia
         ishan@kittymail.com
   - http://utopia.consolemul.com -
*/

/* this source code is GPL
   feel free to use it !!!
*/

/* This demo was  done after watching some GB demo using FMV, at that
   time  i've  thought  it was possible  to do the  same thing on the
   lovely PC-Engine with a better resolution.
   So this  lead to  this,  roughly  done  from  scratch  in 45 mins,
   GFXs included. GFXs  was taken  from  a  video clip  by Appolo 440
   from the Lost in Space zone 2 DVD.  I've used FlaskMPEG to extract
   some  seconds of  the clip  in AVI then  converted 29 frames of it
   into 16 colors PCXs.
*/

/* Greetz:
	- Zeograd for HuC, Hugo and to be one of my best emufriend :)
	- Aramis for the Romu (I hope u can test  this demo some day)
	- Fagemul for... errr... beta testing the code, he ^o^'
	- all the #consolemul crew for testing...
	- and all i've forgotten...

/* some defines  for easy reading */

/* PCX  files must be in 16 colors
   or 16  grey  tones, this  is  a
   limitation of the pce hardware.
   All PCX resolution  are 256x224
   wich is the  default res set by
   HuC.
*/

#define FRAME00 "0.pcx"
#define FRAME01 "1.pcx"
#define FRAME02 "2.pcx"
#define FRAME03 "3.pcx"
#define FRAME04 "4.pcx"
#define FRAME05 "5.pcx"
#define FRAME06 "6.pcx"
#define FRAME07 "7.pcx"
#define FRAME08 "8.pcx"
#define FRAME09 "9.pcx"
#define FRAME10 "10.pcx"
#define FRAME11 "11.pcx"
#define FRAME12 "12.pcx"
#define FRAME13 "13.pcx"
#define FRAME14 "14.pcx"
#define FRAME15 "15.pcx"
#define FRAME16 "16.pcx"
#define FRAME17 "17.pcx"
#define FRAME18 "18.pcx"
#define FRAME19 "19.pcx"
#define FRAME20 "20.pcx"
#define FRAME21 "21.pcx"
#define FRAME22 "22.pcx"
#define FRAME23 "23.pcx"
#define FRAME24 "24.pcx"
#define FRAME25 "25.pcx"
#define FRAME26 "26.pcx"
#define FRAME27 "27.pcx"
#define FRAME28 "28.pcx"


main()
{
	/* nvbl is the number of  Vertical blank to  wait before the
	   next frame
	*/
	int	nvbl;

	/* 60/12 = 5 fps, it's the original movie speed, much slower
	   than the released demo.
	*/
	nvbl =	8;
	
	/* main loop */
	for (;;)
	{

		/* I'm using  the load_background  function
		   from the HuC library. Usualy,  it's used
		   to load (hehe) a  BG but  we  can use it
		   to blit each frame of our anim on screen
		*/
		load_background(f0, p0, b0, 32, 28);

		/* then we wait Vblank a certain nuber of
		   time,  it's  not  really  accurate but
		   2 vbl  is 30 fps,   3 is 20,  4 is 15.
		   Here 12 is 5fps.
		   (i've  discovered that the load_background
		    function  need 3 or 4 vbl to blit a frame
		    wich is damn slow, so the real nvbl value
		    is something more like 8 or 9...
		    This is also why u  see those  bugs while
		    the frame is drawn )
		*/
		vsync(nvbl);

		/* then we do this for all the frame
		*/
		load_background(f1, p1, b1, 32, 28);
		vsync(nvbl);
		load_background(f2, p2, b2, 32, 28);
		vsync(nvbl);
		load_background(f3, p3, b3, 32, 28);
		vsync(nvbl);
		load_background(f4, p4, b4, 32, 28);
		vsync(nvbl);
		load_background(f5, p5, b5, 32, 28);
		vsync(nvbl);
		load_background(f6, p6, b6, 32, 28);
		vsync(nvbl);
		load_background(f7, p7, b7, 32, 28);
		vsync(nvbl);
		load_background(f8, p8, b8, 32, 28);
		vsync(nvbl);
		load_background(f9, p9, b9, 32, 28);
		vsync(nvbl);
		load_background(f10, p10, b10, 32, 28);
		vsync(nvbl);
		load_background(f11, p11, b11, 32, 28);
		vsync(nvbl);
		load_background(f12, p12, b12, 32, 28);
		vsync(nvbl);
		load_background(f13, p13, b13, 32, 28);
		vsync(nvbl);
		load_background(f14, p14, b14, 32, 28);
		vsync(nvbl);
		load_background(f15, p15, b15, 32, 28);
		vsync(nvbl);
		load_background(f16, p16, b16, 32, 28);
		vsync(nvbl);
		load_background(f17, p17, b17, 32, 28);
		vsync(nvbl);
		load_background(f18, p18, b18, 32, 28);
		vsync(nvbl);
		load_background(f19, p19, b19, 32, 28);
		vsync(nvbl);
		load_background(f20, p20, b20, 32, 28);
		vsync(nvbl);
		load_background(f21, p21, b21, 32, 28);
		vsync(nvbl);
		load_background(f22, p22, b22, 32, 28);
		vsync(nvbl);
		load_background(f23, p23, b23, 32, 28);
		vsync(nvbl);
		load_background(f24, p24, b24, 32, 28);
		vsync(nvbl);
		load_background(f25, p25, b25, 32, 28);
		vsync(nvbl);
		load_background(f26, p26, b26, 32, 28);
		vsync(nvbl);
		load_background(f27, p27, b27, 32, 28);
		vsync(nvbl);
		load_background(f28, p28, b28, 32, 28);
		vsync(nvbl);

		/* loop
		*/
	}
}


/* this where we include all the data we need
   ie: GFXs, Palettes, BATs.
   we need  to extract all of these from each
   PCX files.
*/

/* extract the GFX part - 32 and 28 are
   Horizontal  size  and  Vertical size
   of the GFX in  tiles,  each tiles is
   8x8 dots.
*/
#incchr(f0,FRAME00,32,28);

/* extract the palette part */
#incpal(p0,FRAME00);

/* extract  the  so called BAT :)
   BAT  mean  Block ATributs as I
   remember, this is used to give
   the position of each  tiles on
   screen.
*/
#incbat(b0,FRAME00,0x1000,32,28);

/* It's the same for all the frames
*/
#incchr(f1,FRAME01,32,28);
#incpal(p1,FRAME01);
#incbat(b1,FRAME01,0x1000,32,28);

#incchr(f2,FRAME02,32,28);
#incpal(p2,FRAME02);
#incbat(b2,FRAME02,0x1000,32,28);

#incchr(f3,FRAME03,32,28);
#incpal(p3,FRAME03);
#incbat(b3,FRAME03,0x1000,32,28);

#incchr(f4,FRAME04,32,28);
#incpal(p4,FRAME04);
#incbat(b4,FRAME04,0x1000,32,28);

#incchr(f5,FRAME05,32,28);
#incpal(p5,FRAME05);
#incbat(b5,FRAME05,0x1000,32,28);

#incchr(f6,FRAME06,32,28);
#incpal(p6,FRAME06);
#incbat(b6,FRAME06,0x1000,32,28);

#incchr(f7,FRAME07,32,28);
#incpal(p7,FRAME07);
#incbat(b7,FRAME07,0x1000,32,28);

#incchr(f8,FRAME08,32,28);
#incpal(p8,FRAME08);
#incbat(b8,FRAME08,0x1000,32,28);

#incchr(f9,FRAME09,32,28);
#incpal(p9,FRAME09);
#incbat(b9,FRAME09,0x1000,32,28);

#incchr(f10,FRAME10,32,28);
#incpal(p10,FRAME10);
#incbat(b10,FRAME10,0x1000,32,28);

#incchr(f11,FRAME11,32,28);
#incpal(p11,FRAME11);
#incbat(b11,FRAME11,0x1000,32,28);

#incchr(f12,FRAME12,32,28);
#incpal(p12,FRAME12);
#incbat(b12,FRAME12,0x1000,32,28);

#incchr(f13,FRAME13,32,28);
#incpal(p13,FRAME13);
#incbat(b13,FRAME13,0x1000,32,28);

#incchr(f14,FRAME14,32,28);
#incpal(p14,FRAME14);
#incbat(b14,FRAME14,0x1000,32,28);

#incchr(f15,FRAME15,32,28);
#incpal(p15,FRAME15);
#incbat(b15,FRAME15,0x1000,32,28);

#incchr(f16,FRAME16,32,28);
#incpal(p16,FRAME16);
#incbat(b16,FRAME16,0x1000,32,28);

#incchr(f17,FRAME17,32,28);
#incpal(p17,FRAME17);
#incbat(b17,FRAME17,0x1000,32,28);

#incchr(f18,FRAME18,32,28);
#incpal(p18,FRAME18);
#incbat(b18,FRAME18,0x1000,32,28);

#incchr(f19,FRAME19,32,28);
#incpal(p19,FRAME19);
#incbat(b19,FRAME19,0x1000,32,28);

#incchr(f20,FRAME20,32,28);
#incpal(p20,FRAME20);
#incbat(b20,FRAME20,0x1000,32,28);

#incchr(f21,FRAME21,32,28);
#incpal(p21,FRAME21);
#incbat(b21,FRAME21,0x1000,32,28);

#incchr(f22,FRAME22,32,28);
#incpal(p22,FRAME22);
#incbat(b22,FRAME22,0x1000,32,28);

#incchr(f23,FRAME23,32,28);
#incpal(p23,FRAME23);
#incbat(b23,FRAME23,0x1000,32,28);

#incchr(f24,FRAME24,32,28);
#incpal(p24,FRAME24);
#incbat(b24,FRAME24,0x1000,32,28);

#incchr(f25,FRAME25,32,28);
#incpal(p25,FRAME25);
#incbat(b25,FRAME25,0x1000,32,28);

#incchr(f26,FRAME26,32,28);
#incpal(p26,FRAME26);
#incbat(b26,FRAME26,0x1000,32,28);

#incchr(f27,FRAME27,32,28);
#incpal(p27,FRAME27);
#incbat(b27,FRAME27,0x1000,32,28);

#incchr(f28,FRAME28,32,28);
#incpal(p28,FRAME28);
#incbat(b28,FRAME28,0x1000,32,28);

/* EOF */